#!/usr/bin/python
# coding=utf-8

# Les modules nécessaires sont importés et mis en place
import glob
import time
from time import sleep
import RPi.GPIO as GPIO
 
# À ce stade, la pause peut être réglée entre deux mesures
sleeptime = 1
 
# La broche d'entrée One-Wire est déclarée et la résistance intégrée de Pull UP activée
GPIO.setmode(GPIO.BCM)
GPIO.setup(4, GPIO.IN, pull_up_down=GPIO.PUD_UP)
 
# Après l'activation, la résistance de pull-up est maintenue
# jusqu'à ce que la communication soit établie avec le capteur DS18B20
print 'En attente d initialisation...'
 
base_dir = '/sys/bus/w1/devices/'
while True:
    try:
        device_folder = glob.glob(base_dir + '28*')[0]
        break
    except IndexError:
        sleep(0.5)
        continue
device_file = device_folder + '/w1_slave'
 
 
# Définition de la fonction permettant de lire la valeur du capteurF
def mesureTemperature():
    f = open(device_file, 'r')
    lines = f.readlines()
    f.close()
    return lines
 
# Pour l'initialisation, le capteur est lu une fois en "aveugle"
mesureTemperature()
 
# Calcul de la température. Pour les mesures, la communication One-Wire utilise 
# le sous-dossier /sys/bus/w1/devices/. Ce dossier contient le fichier w1-esclave
# dans lequel les données qui ont été envoyées par le bus One-Wire sont stockées.
# Dans cette fonction, les données sont analysées et la température est lue et envoyée
def calculTemperature():
    lines = mesureTemperature()
    while lines[0].strip()[-3:] != 'YES':
        time.sleep(0.2)
        lines = mesureTemperature()
    equals_pos = lines[1].find('t=')
    if equals_pos != -1:
        temp_string = lines[1][equals_pos+2:]
        temp_c = float(temp_string) / 1000.0
        return temp_c
 
# Boucle de programme principale
# La température mesurée est affichée dans la console - une pause paramétrable
# avec "sleeptime" est instaurée entre les mesures
try:
    while True:
        print '---------------------------------------'
        print "Température: ", calculTemperature(), "°C"
        time.sleep(sleeptime)
 
except KeyboardInterrupt:
    GPIO.cleanup()